#if !defined(GEN_UTIL_H)
#define GEN_UTIL_H

#include "gen_typs.h"

#define DB_BYTE_DISPLAY		1
#define DB_WORD_DISPLAY		2
#define DB_DWORD_DISPLAY	4
#define DB_QWORD_DISPLAY	8

#if VDEBUG || !defined(_X8616B)
void	gen_DumpBuffer( U8* Buffer, U32 Count, U32 Display, U32 starting );
#else
#define gen_DumpBuffer( Buffer, Count, Display, starting )
#endif

void	gen_bzero(void* Buffer, U32 ByteCount);
void	gen_memmove(void* pDest, const void* pSrc, U32 ByteCount);

#if !defined(_X8616B)
/*****************************************************************
 *				General Sorted Single Linked List 
 *****************************************************************/
typedef struct _GEN_SORTED_SLIST_HEADER
{
	bpVOID	pHeader;						/* the 1st element in the list */
	U32		NextPointerOffsetInListItem;	/* Next Pointer Offset in the Entry */
	U32		KeyOffsetInListItem;			/* The key used to sort */
} GEN_SORTED_SLIST_HEADER, buf_space* bpGEN_SORTED_SLIST_HEADER;

void 
Gen_Sorted_SList_Initialize(
	bpGEN_SORTED_SLIST_HEADER ListHeader,
	U32 NextPointerOffsetInListItem,
	U32 KeyOffsetInListItem
	);

void
Gen_Sorted_SList_Insert(
	bpGEN_SORTED_SLIST_HEADER ListHeader,
	bpVOID pEntry
	);

bpVOID 
Gen_Sorted_SList_GetFirst(
	bpGEN_SORTED_SLIST_HEADER ListHeader
	);

bpVOID 
Gen_Sorted_SList_GetNext(
	bpGEN_SORTED_SLIST_HEADER ListHeader,
	bpVOID pEntry
	);

BoOL 
Gen_Sorted_SList_IsEmpty(
	bpGEN_SORTED_SLIST_HEADER ListHeader
	);

bpVOID
Gen_Sorted_SList_RemoveHead(
	bpGEN_SORTED_SLIST_HEADER ListHeader
	);

bpVOID
Gen_Sorted_SList_RemoveEntry(
	bpGEN_SORTED_SLIST_HEADER ListHeader,
	bpVOID Entry
	);

BoOL
Gen_Sorted_SList_CheckExist(
	bpGEN_SORTED_SLIST_HEADER ListHeader,
	bpVOID Entry
	);

void
Gen_Sorted_SList_Clear(
	bpGEN_SORTED_SLIST_HEADER ListHeader
	);
#endif

#endif /* GEN_UTIL_H */

