#ifndef OSD_CONS_h
#define OSD_CONS_h

/* driver version related definitions */	
#ifndef KERNEL_VERSION
#define KERNEL_VERSION(x,y,z) (((x)<<16)+((y)<<8)+(z))
#endif

#define VER_MAJOR 		2	
#define VER_MINOR 		8
#define OEM 	0
#define BUILD_VER 	20	

#define SHASTA_DRIVER_VERSION "2.8.0.20"
#define SHASTA_DRIVER_DATE	"(Jun 9, 2005)"

#if !defined(BOOLEAN)
#define BOOLEAN int
#endif

/* controller related definitions */
#if !defined(MAX_ADAPTORS)
#define MAX_ADAPTORS	 16
#endif

#if !defined(PCI_VENDOR_ID_PROMISE)
#define PCI_VENDOR_ID_PROMISE				0x105A
#endif

#define MAX_ADAPTER_TYPE					3
#define PCI_REVISION_ID_ADDRESS			8
#define PCI_VENDOR_ID_INTEL				0x8086
#define PCI_DEVICE_ID_SHASTA				0x0334
#define PCI_DEVICE_ID_SHASTA1				0x0374
#define PCI_DEVICE_ID_SHASTA_P				0x8350
#define VEN_DEV_SHASTA						0x80860334
#define VEN_DEV_SHASTA1					0x80860374
#define VEN_DEV_SHASTA_P					0x105A8350
#define SUB_VEN_DEV_SHASTA				VEN_DEV_SHASTA
#define SUB_VEN_DEV_SHASTA1				VEN_DEV_SHASTA1
#define SUB_VEN_DEV_SHASTA_P				VEN_DEV_SHASTA_P

#define MAX_ARRAY_SUPPORTED			16
#define OSDM_MAX_TARGET_NUM			(MAX_ARRAY_SUPPORTED+1)
#define OSDM_MAX_LUN_PER_TARGET		1

#define CAN_QUEUE 32 
#define SHASTA_MAX_SG 				32
#define MAX_SG 							SHASTA_MAX_SG
#define MAX_TIMER_QUEUE 				32


/* IOCTL related definitions */
#define SHASTA_DEV_NAME			"shasta"
#define FASTTRAK_IOCTL_SIGNATURE1   0x54534146
#define FASTTRAK_IOCTL_SIGNATURE2   0x4b415254

#define MAX_DATA_BUFFER_COUNT 2

#define SRB_STATUS_SUCCESS 1
#define SRB_STATUS_BUSY                     0x05
#define SRB_STATUS_INVALID_REQUEST          0x06
#define SRB_STATUS_SELECTION_TIMEOUT        0x0A
#define SRB_SEE_SENSE 0x84
#define SRB_STATUS_ERROR 0x80

/* Whenever there is a component started, it'll call the OSD_ComponentStarted function. */
#define COMP_START_STATUS_SUCCESS	1

#define PULONG	unsigned int *
#define ULONG unsigned int
#define PUCHAR unsigned char *
#define PUSHORT unsigned short *
#define USHORT unsigned short 
#define UCHAR unsigned char
#define VOID void
#define PVOID void *

#endif /* OSD_CONS_H */

